diff --git a/packaging/aur/PKGBUILD.template b/packaging/aur/PKGBUILD.template
new file mode 100644
index 0000000..21f04e9
--- /dev/null
+++ b/packaging/aur/PKGBUILD.template
@@ -0,0 +1,40 @@
+# Maintainer: hive release bot <release-bot@users.noreply.github.com>
+# TEMPLATE — stamped by packaging/gen_pkgbuild.sh (version + sha256sums).
+pkgname=hive-bin
+pkgver=0.0.0
+pkgrel=1
+pkgdesc="Autonomous software-delivery pipeline driven by coding agent CLIs"
+arch=('x86_64')
+url="https://github.com/ivankuznetsov/hive"
+license=('MIT')
+depends=('bash' 'git')
+optdepends=('yay: AUR helper used by `hive update`'
+            'paru: alternative AUR helper used by `hive update`'
+            'systemd: per-user daemon service unit')
+provides=('hive')
+conflicts=('hive-hive-bin' 'hive-git')
+source=("hive-${pkgver}.tar.gz::https://github.com/ivankuznetsov/hive/releases/download/v${pkgver}/hive-v${pkgver}-linux-x86_64.tar.gz")
+sha256sums=('STAMPED-BY-GEN-PKGBUILD')
+
+package() {
+  cd "${srcdir}/hive-v${pkgver}-linux-x86_64"
+
+  install -Dm755 bin/hive "$pkgdir/usr/bin/hive"
+  if [[ -d share ]]; then
+    cp -R share "$pkgdir/usr/share/hive"
+    find "$pkgdir/usr/share/hive" -type d -exec chmod 755 {} +
+    find "$pkgdir/usr/share/hive" -type f -exec chmod 644 {} +
+    [[ -f "$pkgdir/usr/share/hive/bin/hive" ]] && chmod 755 "$pkgdir/usr/share/hive/bin/hive"
+  fi
+
+  install -Dm644 /dev/null "$pkgdir/usr/share/licenses/${pkgname}/LICENSE"
+}
+
+post_install() {
+  echo "==> next steps: run 'hive init' inside a project, and consider"
+  echo "    systemctl --user enable --now hive.service   (or let hive init do it)"
+}
+
+pre_remove() {
+  :
+}
diff --git a/packaging/build.sh b/packaging/build.sh
new file mode 100755
index 0000000..c3fae37
--- /dev/null
+++ b/packaging/build.sh
@@ -0,0 +1,185 @@
+#!/usr/bin/env bash
+# packaging/build.sh — build one self-contained hive release tarball.
+#
+# Plan figure-out-way-to-install-260513-4a0a (U3). Produces an artifact of
+# the FIXED shape every distribution channel consumes:
+#
+#   hive-<semver>-<os>-<arch>.tar.gz
+#     bin/hive                  ← entry point (launcher script)
+#     share/hive/               ← app payload (lib, bin, templates, schemas,
+#                                 config, Gemfile(.lock), vendor/bundle)
+#     embedded-ruby/            ← hermetic Ruby runtime (portable backend)
+#     SHA256SUMS                ← manifest of all artifact files
+#
+# Backends:
+#   PACKAGING_BACKEND=tebako    attempt Tebako static packing first
+#                               (embedded FS; single-file binary). This is
+#                               the PRIMARY strategy per plan U3. The real
+#                               spike runs in the release workflow gate job;
+#                               this OSS tree keeps the hook (see
+#                               attempt_tebako below) so the decision is
+#                               contained to one function.
+#   PACKAGING_BACKEND=portable  portable-Ruby bundle (hermetic Ruby +
+#                               vendored runtime gems) — the sanctioned
+#                               FALLBACK when FFI gem loading
+#                               (bubbletea/lipgloss → Charm Go libs)
+#                               misbehaves inside a packed binary. Same
+#                               artifact shape, so no downstream channel
+#                               changes either way.
+#   PACKAGING_BACKEND=auto      (default) try tebako, fall back on failure.
+#
+# Local verification without CI / network:
+#   rake 'release:tarball[v0.1.0]'                 # system-ruby dev tarball
+#   test/packaging/smoke_tarball.sh <artifact>     # extract + run checks
+set -euo pipefail
+
+SCRIPT_DIR="$(cd "$(dirname "${BASH_SOURCE[0]}")" && pwd)"
+REPO_ROOT="$(cd "$SCRIPT_DIR/.." && pwd)"
+VERSION="${1:-${HIVE_VERSION:?pass VERSION as argv[1] or set HIVE_VERSION}}"
+
+BACKEND="${PACKAGING_BACKEND:-auto}"
+OS="$(uname -s | tr '[:upper:]' '[:lower:]')"
+ARCH="$(uname -m)"
+case "$ARCH" in
+  x86_64|amd64) ARCH="x86_64" ;;
+  aarch64|arm64) ARCH="arm64" ;;
+  *) echo "build.sh: unsupported arch $ARCH" >&2; exit 1 ;;
+esac
+ARTIFACT_NAME="hive-${VERSION}-${OS}-${ARCH}"
+WORK="$(mktemp -d "${TMPDIR:-/tmp}/hive-build.XXXXXX")"
+STAGE="$WORK/$ARTIFACT_NAME"
+trap 'rm -rf "$WORK"' EXIT
+
+log() { printf '[build.sh] %s\n' "$*"; }
+
+# Copy the app payload preserving the lib/../templates layout the code
+# resolves at runtime via __dir__-relative lookups.
+stage_payload() {
+  log "staging app payload into $STAGE/share/hive"
+  mkdir -p "$STAGE/share/hive/bin" "$STAGE/bin"
+  cp -R \
+    "$REPO_ROOT/lib" \
+    "$REPO_ROOT/templates" \
+    "$REPO_ROOT/schemas" \
+    "$REPO_ROOT/config" \
+    "$REPO_ROOT/Gemfile" "$REPO_ROOT/Gemfile.lock" \
+    "$REPO_ROOT/.ruby-version" \
+    "$STAGE/share/hive/"
+  cp "$REPO_ROOT/bin/hive" "$STAGE/share/hive/bin/hive-real"
+  chmod +x "$STAGE/share/hive/bin/hive-real"
+}
+
+write_launcher() {
+  cat > "$STAGE/bin/hive" <<LAUNCHER
+#!/usr/bin/env bash
+# Generated by packaging/build.sh for $ARTIFACT_NAME. Do not edit by hand.
+set -euo pipefail
+HERE="\$(cd "\$(dirname "\$(readlink -f "\$0")")" && pwd)"
+APP="\$HERE/../share/hive"
+export HIVE_PACKAGED="$ARTIFACT_NAME"
+EMBEDDED="\$HERE/../embedded-ruby/bin/ruby"
+if [[ -x "\$EMBEDDED" ]]; then
+  export RUBYOPT=""
+  cd "\$APP"
+  exec "\$EMBEDDED" -I"\$APP/lib" \\
+       "\$HERE/../embedded-ruby/bin/bundle" exec "\$EMBEDDED" bin/hive-real "\$@"
+else
+  # Tebako-backed single-file binary layout or system-ruby dev fallback.
+  if [[ -x "\$APP/packed/hive" ]]; then
+    exec "\$APP/packed/hive" "\$@"
+  else
+    exec "\${RUBY:-ruby}" -I"\$APP/lib" "\$APP/bin/hive-real" "\$@"
+  fi
+fi
+LAUNCHER
+  chmod +x "$STAGE/bin/hive"
+}
+
+bundle_vendored_gems() {
+  if [[ "${HIVE_SKIP_VENDOR_BUNDLE:-}" == "1" ]]; then
+    log "HIVE_SKIP_VENDOR_BUNDLE=1 → skipping gem vendoring (dev smoke tarball)"
+    return 0
+  fi
+  log "vendoring runtime gems (bundle install --path vendor/bundle)"
+  (
+    cd "$STAGE/share/hive"
+    bundle config set --local path vendor/bundle
+    bundle config set --local without development:test
+    bundle install
+  )
+}
+
+embed_portable_ruby() {
+  log "backend=portable: embedding hermetic Ruby under embedded-ruby/"
+  mkdir -p "$STAGE/embedded-ruby"
+  if [[ -n "${PORTABLE_RUBY_SOURCE:-}" ]]; then
+    cp -a "${PORTABLE_RUBY_SOURCE%/}/." "$STAGE/embedded-ruby/"
+    return 0
+  fi
+  log "PORTABLE_RUBY_SOURCE not set; building dev tarball WITHOUT an " \
+      "embedded runtime (wrapper falls back to system ruby — fine for local " \
+      "smoke tests; CI sets PORTABLE_RUBY_SOURCE)"
+  return 0
+}
+
+attempt_tebako() {
+  log "backend=tebako: attempting static packing of bin/hive-real"
+  # The packed binary lands here; the OSS tree carries only the seam so the
+  # spike stays reviewable without shipping Docker/Darling toolchains in-repo:
+  #   scripts/packaging/tebako_pack.sh <gem_root> <out_bin>
+  if [[ -x "$REPO_ROOT/scripts/packaging/tebako_pack.sh" ]]; then
+    mkdir -p "$STAGE/share/hive/packed"
+    bash "$REPO_ROOT/scripts/packaging/tebako_pack.sh" \
+      "$STAGE/share/hive" "$STAGE/share/hive/packed/hive"
+    return $?
+  fi
+  log "tebako packer not present (expected in the CI gate); skipping"
+  return 1
+}
+
+finalize_artifact() {
+  write_launcher
+  log "generating SHA256SUMS"
+  (
+    cd "$STAGE"
+    find . -type f ! -name SHA256SUMS -print0 |
+      LC_ALL=C sort -z |
+      xargs -0 sha256sum > SHA256SUMS
+  )
+
+  local out_dir="${HIVE_ARTIFACT_DIR:-$REPO_ROOT/tmp/release}"
+  mkdir -p "$out_dir"
+  local tarball="$out_dir/$ARTIFACT_NAME.tar.gz"
+  tar -czf "$tarball" -C "$WORK" "$ARTIFACT_NAME"
+  log "wrote $tarball"
+
+  # Emit macOS-specific hardening note for the calling CI leg.
+  if [[ "$(uname -s)" == "Darwin" ]]; then
+    log "darwin leg: run codesign --force --sign - on all Mach-O files " \
+        "and xattr -c before uploading (notarization deferred; see Risks #2)"
+  fi
+}
+
+case "$BACKEND" in
+  tebako|auto)
+    stage_payload
+    if ! attempt_tebako && [[ "$BACKEND" == "tebako" ]]; then
+      log "tebako failed and was forced via PACKAGING_BACKEND=tebako"; exit 1
+    fi
+    if [[ ! -x "$STAGE/share/hive/packed/hive" ]]; then
+      embed_portable_ruby
+      bundle_vendored_gems
+    fi
+    finalize_artifact
+    ;;
+  portable)
+    stage_payload
+    embed_portable_ruby
+    bundle_vendored_gems
+    finalize_artifact
+    ;;
+  *)
+    echo "build.sh: unknown PACKAGING_BACKEND '$BACKEND' (auto|tebako|portable)" >&2
+    exit 1
+    ;;
+esac
diff --git a/packaging/gen_pkgbuild.sh b/packaging/gen_pkgbuild.sh
new file mode 100755
index 0000000..e5e5178
--- /dev/null
+++ b/packaging/gen_pkgbuild.sh
@@ -0,0 +1,28 @@
+#!/usr/bin/env bash
+# packaging/gen_pkgbuild.sh — stamp pkgver + sha256sums into the AUR
+# PKGBUILD from a release SHA256SUMS manifest, then regenerate .SRCINFO via
+# makepkg. Used by the release workflow (U9) before pushing an AUR update.
+#
+# Usage: gen_pkgbuild.sh <version-without-v> <SHA256SUMS-path>
+set -euo pipefail
+
+VERSION="${1:?usage: gen_pkgbuild.sh <X.Y.Z> <SHA256SUMS>}"
+SUMS="${2:?usage: gen_pkgbuild.sh <X.Y.Z> <SHA256SUMS>}"
+
+DIGEST="$(grep "hive-v${VERSION}-linux-x86_64.tar.gz" "$SUMS" | awk '{print $1}')"
+[[ -n "$DIGEST" ]] || { echo "no checksum found for hive-v${VERSION}-linux-x86_64.tar.gz in $SUMS" >&2; exit 1; }
+
+DIR="$(cd "$(dirname "${BASH_SOURCE[0]}")" && pwd)"
+
+sed \
+  -e "s/^pkgver=.*/pkgver=${VERSION}/" \
+  -e "s|^sha256sums=('.*')|sha256sums=('${DIGEST}')|" \
+  "${DIR}/aur/PKGBUILD.template" > "${DIR}/aur/PKGBUILD"
+
+if command -v makepkg >/dev/null 2>&1; then
+  (cd "${DIR}" && makepkg --printsrcinfo > .SRCINFO)
+else
+  echo "WARN: makepkg unavailable — .SRCINFO not regenerated (AUR CI will do it)" >&2
+fi
+
+echo "[gen_pkgbuild.sh] PKGBUILD updated to ${VERSION} (${DIGEST})"
diff --git a/packaging/install.sh b/packaging/install.sh
new file mode 100755
index 0000000..2cae886
--- /dev/null
+++ b/packaging/install.sh
@@ -0,0 +1,292 @@
+#!/usr/bin/env bash
+# packaging/install.sh — curl one-liner installer (plan U10 / R5).
+#
+#   curl -fsSL https://github.com/ivankuznetsov/hive/releases/latest/download/install.sh | bash
+#
+# Behavior contract:
+#   * strict mode everywhere; hard-fails on ANY checksum mismatch BEFORE
+#     touching the target tree
+#   * no sudo anywhere by default (installs under $HOME XDG paths);
+#     refuses running as root unless --allow-root is passed explicitly
+#   * OS/arch detected from uname -s/-m (+ /etc/os-release for tier notes);
+#     tier-3 targets are refused with a clear message
+#   * default binary name: hive — falls back to hv automatically when an
+#     unrelated `hive` already exists on PATH (e.g. Apache Hive); override
+#     with HIVE_COMMAND_NAME=hv
+#   * extracts the self-contained tarball into ~/.local/share/hive and
+#     symlinks ~/.local/bin/<name> -> ../share/hive/bin/hive
+#   * writes the install receipt (~/.config/hive/install.yml) consumed by
+#     `hive update` / `hive uninstall`
+#   * strips the macOS quarantine xattr from downloaded Mach-O files
+#   * never edits shell rc files silently: prints the exact line to append
+#     when ~/.local/bin is not on PATH
+#   * `--uninstall` reverses ONLY script-owned bits (launcher symlink +
+#     this artifact's manifest bookkeeping) — data dirs are left untouched
+#
+# Env knobs:
+#   HIVE_VERSION       pin an exact release tag (recommended for agents)
+#   HIVE_RELEASE_BASE  base URL for artifacts + SHA256SUMS + install.sh
+#                      itself; defaults to GitHub Releases "latest/download".
+#                      Point at a local directory for offline tests.
+set -euo pipefail
+
+GITHUB_REPO="${HIVE_GITHUB_REPO:-ivankuznetsov/hive}"
+DEFAULT_RELEASE_BASE="https://github.com/${GITHUB_REPO}/releases/latest/download"
+RELEASE_BASE="${HIVE_RELEASE_BASE:-$DEFAULT_RELEASE_BASE}"
+PINNED_VERSION="${HIVE_VERSION:-}"
+PREFIX_ROOT="${HOME}/.local"
+APP_DIR="${HIVE_INSTALL_APP_DIR:-${PREFIX_ROOT}/share/hive}"
+BIN_DIR="${HIVE_INSTALL_BIN_DIR:-${PREFIX_ROOT}/bin}"
+MODE="install"
+ALLOW_ROOT=0
+WORK="" # mktemp dir for install; cleaned via EXIT trap
+
+log() { printf '[install.sh] %s\n' "$*"; }
+die() { printf '[install.sh] ERROR: %s\n' "$*" >&2; exit 1; }
+
+usage() {
+  cat <<USAGE
+Usage: install.sh [--uninstall] [--allow-root]
+
+Installs self-contained hive (vendored Ruby, no system Ruby needed).
+
+Env:
+  HIVE_VERSION=<vX.Y.Z>        pin release tag (strongly recommended)
+  HIVE_RELEASE_BASE=<url>      artifact base (default: GitHub latest/download)
+  HIVE_COMMAND_NAME=<name>     force binary name (hive | hv)
+
+Options:
+  --uninstall   remove only script-owned bits; data dirs preserved
+  --allow-root  permit running as root (CI containers only)
+  --help        this text
+USAGE
+}
+
+while [[ $# -gt 0 ]]; do
+  case "$1" in
+    --uninstall) MODE="uninstall" ;;
+    --allow-root) ALLOW_ROOT=1 ;;
+    -h|--help) usage; exit 0 ;;
+    *) die "unknown option: $1 (see --help)" ;;
+  esac
+  shift
+done
+
+if [[ $EUID -eq 0 && $ALLOW_ROOT -ne 1 ]]; then
+  die "refusing to run as root (per-user install). Pass --allow-root only in disposable containers."
+fi
+
+cleanup_work() {
+  [[ -n "$WORK" && -d "$WORK" ]] && rm -rf "$WORK"
+  return 0
+}
+
+detect_platform() {
+  local os arch
+  os="$(uname -s | tr '[:upper:]' '[:lower:]')"
+  arch="$(uname -m)"
+  case "$arch" in x86_64|amd64) arch=x86_64 ;; aarch64|arm64) arch=arm64 ;; *)
+    die "unsupported architecture: $(uname -m)"
+  esac
+
+  case "$os" in
+    darwin) PLATFORM="darwin" ;;
+    linux)  PLATFORM="linux" ;;
+    *) die "unsupported OS '$os'. Tier-3 platforms (BSDs, NixOS, Alpine…) are out of scope for v1." ;;
+  esac
+
+  if [[ "$PLATFORM" == "linux" && -r /etc/os-release ]]; then
+    # shellcheck disable=SC1091
+    . /etc/os-release
+    log "detected distro ${ID:-unknown} ${VERSION_ID:-}" >&2
+    case "${ID:-}" in
+      ubuntu|pop|neon|debian|fedora|rhel|arch|manjaro|endeavouros|centos) : ;;
+      *) echo "[install.sh] note: untested distro '${ID:-unknown}' — proceeding best-effort." >&2 ;;
+    esac
+  fi
+  ARTIFACT_NAME="hive-${PINNED_VERSION:-latest}-${PLATFORM}-${arch}"
+  export PLATFORM ARCH="$arch" ARTIFACT_NAME
+}
+
+fetch() {
+  # fetch <relative-path> ; body to stdout
+  local rel="$1"
+  if [[ -d "$RELEASE_BASE" ]]; then
+    # Local testing base (offline): plain filesystem checkout dir.
+    cat "${RELEASE_BASE%/}/$(basename "$rel")"
+    return
+  fi
+  if command -v curl >/dev/null 2>&1; then
+    curl -fsSL "${RELEASE_BASE%/}/${rel}" || die "download failed: ${rel}"
+  elif command -v wget >/dev/null 2>&1; then
+    wget -qO- "${RELEASE_BASE%/}/${rel}" || die "download failed: ${rel}"
+  else
+    die "need curl or wget to download artifacts"
+  fi
+}
+
+resolve_pinned_version() {
+  if [[ -d "$RELEASE_BASE" ]]; then return 0; fi # offline fixture
+
+  if [[ "${RELEASE_BASE:-}" == *"releases/download/"* ]]; then
+    # A /releases/download/<tag>/ base pins implicitly.
+    local tag
+    tag="$(printf '%s' "$RELEASE_BASE" | sed 's|.*/releases/download/\([^/]*\)/.*||')"
+    [[ -z "$PINNED_VERSION" ]] && PINNED_VERSION="$tag"
+    return 0
+  fi
+
+  if [[ -n "$PINNED_VERSION" ]]; then
+    RELEASE_BASE="https://github.com/${GITHUB_REPO}/releases/download/${PINNED_VERSION}"
+    return 0
+  fi
+
+  log "resolving latest release tag via GitHub API"
+  local body tag=""
+  if command -v curl >/dev/null 2>&1; then
+    body=$(curl -fsSL "https://api.github.com/repos/${GITHUB_REPO}/releases/latest" || true)
+  elif command -v wget >/dev/null 2>&1; then
+    body=$(wget -qO- "https://api.github.com/repos/${GITHUB_REPO}/releases/latest" || true)
+  fi
+  tag="$(printf '%s' "${body:-}" | grep -m1 'tag_name' | sed 's|.*: *"\([^"]*\)".*||' || true)"
+  if [[ -n "$tag" ]]; then
+    PINNED_VERSION="$tag"
+    RELEASE_BASE="https://github.com/${GITHUB_REPO}/releases/download/${tag}"
+    log "latest release: ${tag}"
+  else
+    cat >&2 <<RATELIMIT
+[install.sh] WARN: could not resolve the latest tag from the GitHub API
+(common with unauthenticated rate limits). Pin a version instead:
+
+  curl ... | HIVE_VERSION=v0.1.0 bash
+
+Continuing against the '/latest/download' convention (works when the release
+job also publishes hive-latest-* aliases).
+RATELIMIT
+  fi
+}
+
+verify_checksums() {
+  # verify_checksums <local-file> <sums-file> <published-name>
+  local file="$1" sums="$2" published_name="$3"
+  local expected_line
+  expected_line="$(grep -E "(^|[[:space:]])${published_name}\$" "$sums" | head -n1 || true)"
+  [[ -n "$expected_line" ]] || die "no checksum entry for ${published_name}"
+  local expected actual
+  expected="$(printf '%s\n' "$expected_line" | awk '{print $1}')"
+  if command -v sha256sum >/dev/null 2>&1; then
+    actual="$(sha256sum "$file" | awk '{print $1}')"
+  elif command -v shasum >/dev/null 2>&1; then
+    actual="$(shasum -a 256 "$file" | awk '{print $1}')"
+  else
+    die "need sha256sum or shasum to verify checksums"
+  fi
+  [[ "$expected" == "$actual" ]] || die "CHECKSUM MISMATCH for ${published_name}: expected ${expected}, got ${actual}. No files were written."
+}
+
+decide_command_name() {
+  if [[ -n "${HIVE_COMMAND_NAME:-}" ]]; then
+    COMMAND_NAME="$HIVE_COMMAND_NAME"
+    return
+  fi
+  # R13: Apache Hive collision → fall back to `hv`.
+  if command -v hive >/dev/null 2>&1; then
+    COMMAND_NAME="hv"
+    log "'hive' already exists on PATH ($(command -v hive)) — installing as 'hv'"
+  else
+    COMMAND_NAME="hive"
+  fi
+}
+
+write_receipt() {
+  local cfg_dir="${HIVE_HOME:-${XDG_CONFIG_HOME:-$HOME/.config}/hive}"
+  mkdir -p "$cfg_dir"
+  cat > "${cfg_dir}/install.yml" <<RECEIPT
+---
+channel: script
+version: ${PINNED_VERSION:-unknown}
+command_name: ${COMMAND_NAME}
+binary_path: ${BIN_DIR}/${COMMAND_NAME}
+release_base: ${RELEASE_BASE}
+installed_at: $(date -u +%Y-%m-%dT%H:%M:%SZ)
+RECEIPT
+  touch "$APP_DIR/.hive-script-install"
+}
+
+do_install() {
+  resolve_pinned_version
+  detect_platform
+  decide_command_name
+
+  local worktmp
+  worktmp="$(mktemp -d "${TMPDIR:-/tmp}/hive-install.XXXXXX")"
+  WORK="$worktmp"
+  trap cleanup_work EXIT
+
+  log "downloading SHA256SUMS + ${ARTIFACT_NAME}.tar.gz from ${RELEASE_BASE}"
+  fetch "SHA256SUMS" > "${WORK}/SHA256SUMS"
+  fetch "${ARTIFACT_NAME}.tar.gz" > "${WORK}/artifact.tar.gz"
+
+  verify_checksums "${WORK}/artifact.tar.gz" "${WORK}/SHA256SUMS" "${ARTIFACT_NAME}.tar.gz"
+
+  log "extracting into ${APP_DIR}"
+  mkdir -p "$APP_DIR" "$BIN_DIR"
+  tar -xzf "${WORK}/artifact.tar.gz" -C "$APP_DIR" --strip-components=1
+
+  if [[ "$PLATFORM" == "darwin" ]]; then
+    # Gatekeeper mitigation: unsigned-but-adhoc-signed binaries get the
+    # quarantine xattr on download. Strip it from everything we extracted.
+    command -v xattr >/dev/null 2>&1 &&
+      find "$APP_DIR" -type f -print0 | xargs -0 xattr -d com.apple.quarantine 2>/dev/null || true
+  fi
+
+  ln -sfn "${APP_DIR}/bin/hive" "${BIN_DIR}/${COMMAND_NAME}"
+
+  write_receipt
+
+  case ":${PATH}:" in
+    *":${BIN_DIR}:"*) : ;;
+    *)
+      cat <<PATH_HINT
+
+[install.sh] NOTE: ${BIN_DIR} is not on your PATH. Append this line to your
+shell profile (we will NOT edit rc files silently):
+
+  export PATH="${BIN_DIR}:\$PATH"
+
+PATH_HINT
+      ;;
+  esac
+
+  "${BIN_DIR}/${COMMAND_NAME}" --version &&
+    log "installed as ${COMMAND_NAME} ($( "${BIN_DIR}/${COMMAND_NAME}" --version )) — run '${COMMAND_NAME} init' to bootstrap a project" ||
+    log "WARNING: ${BIN_DIR}/${COMMAND_NAME} did not answer --version; check the extracted tree"
+}
+
+do_uninstall() {
+  detect_platform
+  decide_command_name
+  log "reversing script-owned bits only (data dirs are preserved)"
+
+  local removed=0 link target
+  for candidate in "$COMMAND_NAME" "hive" "hv"; do
+    link="${BIN_DIR}/${candidate}"
+    [[ -L "$link" ]] || continue
+    target="$(readlink "$link")"
+    case "$target" in
+      "${APP_DIR}"*)
+        rm -f "$link"
+        removed=$((removed + 1))
+        ;;
+    esac
+  done
+
+  rm -f "${APP_DIR}/.hive-script-install"
+  log "removed ${removed} launcher symlink(s); kept: \$HIVE_HOME config, state dirs, project scaffolds"
+  log "run '${COMMAND_NAME} uninstall' for the full preserve-by-default teardown flow"
+}
+
+case "$MODE" in
+  install) do_install ;;
+  uninstall) do_uninstall ;;
+esac
diff --git a/packaging/rehearsal/d_preserve.sh b/packaging/rehearsal/d_preserve.sh
new file mode 100755
index 0000000..9daf7e6
--- /dev/null
+++ b/packaging/rehearsal/d_preserve.sh
@@ -0,0 +1,79 @@
+#!/usr/bin/env bash
+# packaging/rehearsal/d_preserve.sh — acceptance scenario D diff harness
+# (plan figure-out-way-to-install U7/U12): run `hive uninstall` against a
+# sandboxed project set and assert the preserve-by-default invariant via a
+# before/after filesystem diff.
+#
+#   bash packaging/rehearsal/d_preserve.sh [tmp-root]
+#
+# Exits non-zero on any invariant violation. Designed for the tier-1
+# rehearsal containers; everything is stubbed/staged inside TMPROOT.
+set -euo pipefail
+
+TMPROOT="${1:-$(mktemp -d "${TMPDIR:-/tmp}/hive-rehearsalD.XXXXXX")}"
+REPO_ROOT="$(cd "$(dirname "${BASH_SOURCE[0]}")/../.." && pwd)"
+HIVE_BIN="$REPO_ROOT/bin/hive"
+
+mkdir -p "$TMPROOT"
+SANDBOX_HOME="$TMPROOT/hive-home"
+export HIVE_HOME="$SANDBOX_HOME"
+
+fail() { echo "[rehearsal-D] FAIL: $*" >&2; exit 1; }
+snap() {
+  # snap <tag>
+  ( cd "$TMPROOT" && find hive-home projects -type f -o -type l 2>/dev/null | LC_ALL=C sort |
+      xargs -r -d '\n' sha256sum 2>/dev/null ) > "$TMPROOT/snap-$1.txt"
+}
+
+# ── Fixture: one project with scaffold + accumulated work ──────────────
+PROJECT="$TMPROOT/projects/demo"
+mkdir -p "$PROJECT" "$SANDBOX_HOME"
+(
+  cd "$PROJECT"
+  git init -q -b master
+  git config user.email r@h.test
+  git config user.name rehearser
+  echo hi > README.md
+  git add . && git commit -qm "initial"
+)
+bash -c "cd '$PROJECT' && ruby -I'$REPO_ROOT/lib' '$HIVE_BIN' init" > /dev/null
+
+mkdir -p "$SANDBOX_HOME/state/keep-me"
+echo operator-state > "$SANDBOX_HOME/state/keep-me/state.txt"
+
+snap before
+
+# ── Non-TTY plain uninstall: must change nothing ────────────────────────
+bash -c "cd '$PROJECT' && ruby -I'$REPO_ROOT/lib' '$HIVE_BIN' uninstall" \
+  > "$TMPROOT/uninstall-plain.log" 2>&1 ||
+  fail "plain uninstall exited non-zero"
+snap after-plain
+if ! diff -q "$TMPROOT/snap-before.txt" "$TMPROOT/snap-after-plain.txt" > /dev/null; then
+  fail "plain uninstall modified files (must be a pure plan print)"
+fi
+grep -q "nothing has been changed" "$TMPROOT/uninstall-plain.log" ||
+  fail "plain uninstall did not announce no-op"
+echo "[rehearsal-D] ok — plain non-TTY uninstall changed nothing"
+
+# ── --purge subset: service+receipt+registry tidy only ──────────────────
+ruby -I"$REPO_ROOT/lib" -e '
+require "hive"
+require "hive/config"
+require "hive/commands/uninstall"
+require "hive/install_receipt"
+require "hive/service"
+Hive::InstallReceipt.write!(channel: "script", version: "v0.0.0")
+module Hive::Service
+  define_singleton_method(:unload!) { true }
+  define_singleton_method(:remove_manifest!) { false }
+end
+exit Hive::Commands::Uninstall.new(purge: true, out: File.open(File::NULL, "w"), err: File.open(File::NULL, "w")).call
+' || fail "--purge failed"
+[[ ! -f "$SANDBOX_HOME/install.yml" ]] || fail "--purge left the receipt behind"
+[[ -f "$SANDBOX_HOME/state/keep-me/state.txt" ]] || fail "--purge touched per-user state"
+scaffold="$PROJECT/.hive"
+[[ -d "$scaffold" ]] || fail "--purge deleted project scaffold (work data must survive)"
+echo "[rehearsal-D] ok — --purge removed receipt+service, preserved all work data"
+
+diff -q "$TMPROOT/snap-before.txt" "$TMPROOT/snap-after-plain.txt" > /dev/null &&
+  echo "[rehearsal-D] ALL INVARIANTS GREEN in $TMPROOT"
diff --git a/test/e2e/lib/artifact_capture.rb b/test/e2e/lib/artifact_capture.rb
index e555061..f8badef 100644
--- a/test/e2e/lib/artifact_capture.rb
+++ b/test/e2e/lib/artifact_capture.rb
@@ -48,7 +48,7 @@ module Hive
           guard("pane-after.txt") { write("pane-after.txt", safe_pane_capture(tmux_driver)) }
           guard("pane-before.txt") { write("pane-before.txt", pane_before) } if pane_before
         end
-        guard("state") { copy_tree(File.join(@sandbox_dir, ".hive-state", "stages"), File.join(@scenario_dir, "state")) }
+        guard("state") { copy_tree(File.join(@sandbox_dir, ".hive", "stages"), File.join(@scenario_dir, "state")) }
         guard("logs") { copy_logs_with_tails }
         guard("tui-subprocess") { copy_tui_subprocess_diagnostics }
         guard("step-results.json") { write("step-results.json", JSON.pretty_generate(step_results)) }
@@ -96,12 +96,12 @@ module Hive
         "(capture-pane failed: #{e.class}: #{e.message})\n"
       end
 
-      # Replace the broad copy_tree of .hive-state/logs with a per-file copy
+      # Replace the broad copy_tree of .hive/logs with a per-file copy
       # that ALSO writes a `<basename>.tail` containing the last N lines, so
       # agents reading artifacts can scan the recent activity quickly without
       # rg'ing through a multi-MB log.
       def copy_logs_with_tails
-        source = File.join(@sandbox_dir, ".hive-state", "logs")
+        source = File.join(@sandbox_dir, ".hive", "logs")
         return unless File.directory?(source)
 
         Dir.glob(File.join(source, "**", "*.log")).each do |full_path|
diff --git a/test/e2e/lib/artifact_capture_test.rb b/test/e2e/lib/artifact_capture_test.rb
index 8a91e29..a9aba03 100644
--- a/test/e2e/lib/artifact_capture_test.rb
+++ b/test/e2e/lib/artifact_capture_test.rb
@@ -65,7 +65,7 @@ class E2EArtifactCaptureTest < Minitest::Test
 
   def test_log_tails_are_last_n_lines_per_log_file
     with_dirs do |scenario_dir, sandbox, run_home|
-      logs_root = File.join(sandbox, ".hive-state", "logs", "myslug")
+      logs_root = File.join(sandbox, ".hive", "logs", "myslug")
       FileUtils.mkdir_p(logs_root)
       log_path = File.join(logs_root, "stage.log")
       File.write(log_path, (1..500).map { |i| "line#{i}\n" }.join)
diff --git a/test/e2e/lib/repro_script_writer.rb b/test/e2e/lib/repro_script_writer.rb
index 2264457..91f0fb1 100644
--- a/test/e2e/lib/repro_script_writer.rb
+++ b/test/e2e/lib/repro_script_writer.rb
@@ -131,7 +131,7 @@ module Hive
         stage = safe_stage(stage)
         slug = PathSafety.safe_basename!(slug, "seed_state slug")
         project_root = project_root_for(step.args["project"])
-        folder = File.join(project_root, ".hive-state", "stages", stage, slug)
+        folder = File.join(project_root, ".hive", "stages", stage, slug)
         lines = [
           "# step #{step.position} seed_state: #{stage}/#{slug}",
           "mkdir -p #{Shellwords.escape(folder)}",
@@ -339,7 +339,7 @@ module Hive
           "require 'yaml'",
           "project = ARGV.fetch(0)",
           "run_dir = ARGV.fetch(1)",
-          "cfg_path = File.join(project, '.hive-state', 'config.yml')",
+          "cfg_path = File.join(project, '.hive', 'config.yml')",
           "cfg = YAML.safe_load(File.read(cfg_path)) || {}",
           "cfg['worktree_root'] = File.join(run_dir, 'worktrees')",
           "cfg['review'] ||= {}",
diff --git a/test/e2e/lib/repro_script_writer_test.rb b/test/e2e/lib/repro_script_writer_test.rb
index 4be7c9d..467bdb4 100644
--- a/test/e2e/lib/repro_script_writer_test.rb
+++ b/test/e2e/lib/repro_script_writer_test.rb
@@ -233,7 +233,7 @@ class E2EReproScriptWriterTest < Minitest::Test
 
           body = File.read(path)
           assert_includes body, "expanded-slug", "CLI args should be expanded before replay"
-          assert_includes body, File.join(sandbox, ".hive-state", "stages", "4-execute", "expanded-slug", "task.md"),
+          assert_includes body, File.join(sandbox, ".hive", "stages", "4-execute", "expanded-slug", "task.md"),
                           "per-step env should be expanded before replay"
           assert_includes body, "if [ \"$status\" -ne 75 ]",
                           "expected non-zero exits should not abort under set -e before validation"
diff --git a/test/e2e/lib/sandbox.rb b/test/e2e/lib/sandbox.rb
index 73fa3b8..d881ab3 100644
--- a/test/e2e/lib/sandbox.rb
+++ b/test/e2e/lib/sandbox.rb
@@ -178,7 +178,7 @@ module Hive
       end
 
       def tune_project_config(path)
-        cfg_path = File.join(path, ".hive-state", "config.yml")
+        cfg_path = File.join(path, ".hive", "config.yml")
         cfg = YAML.safe_load(File.read(cfg_path)) || {}
         cfg["worktree_root"] = File.join(@run_dir, "worktrees")
         cfg["review"] ||= {}
diff --git a/test/e2e/lib/sandbox_test.rb b/test/e2e/lib/sandbox_test.rb
index 497efed..782f4c8 100644
--- a/test/e2e/lib/sandbox_test.rb
+++ b/test/e2e/lib/sandbox_test.rb
@@ -25,7 +25,7 @@ class E2ESandboxTest < Minitest::Test
     Dir.mktmpdir("e2e-run") do |dir|
       sandbox = Hive::E2E::Sandbox.bootstrap(dir)
 
-      assert File.directory?(File.join(sandbox.sandbox_dir, ".hive-state"))
+      assert File.directory?(File.join(sandbox.sandbox_dir, ".hive"))
       config = YAML.safe_load(File.read(File.join(sandbox.run_home, "config.yml")))
       assert_equal [ "sandbox" ], config.fetch("registered_projects").map { |project| project.fetch("name") }
     end
diff --git a/test/e2e/lib/step_executor.rb b/test/e2e/lib/step_executor.rb
index ce02c76..b4bbd7e 100644
--- a/test/e2e/lib/step_executor.rb
+++ b/test/e2e/lib/step_executor.rb
@@ -177,7 +177,7 @@ module Hive
         stage = safe_stage!(expand_string(step.args.fetch("stage")), step)
         slug = PathSafety.safe_basename!(expand_string(step.args["slug"] || "#{@scenario.name.tr('_', '-')}-task"), "seed_state slug")
         @ctx.slug_default!(slug)
-        folder = File.join(project_dir, ".hive-state", "stages", stage, slug)
+        folder = File.join(project_dir, ".hive", "stages", stage, slug)
         FileUtils.mkdir_p(folder)
         state_file = contained_relative_path(folder, step.args["state_file"] || default_state_file(stage), "seed_state state_file")
         File.write(state_file, expand_string(step.args["content"] || default_state_content(slug, stage)))
@@ -320,7 +320,7 @@ module Hive
       def current_slug
         return @ctx.slug if @ctx.slug
 
-        stages = Dir[File.join(@ctx.sandbox_dir, ".hive-state", "stages", "*", "*")].select { |path| File.directory?(path) }
+        stages = Dir[File.join(@ctx.sandbox_dir, ".hive", "stages", "*", "*")].select { |path| File.directory?(path) }
         raise StepFailure.new(nil, "no task slug found in sandbox") if stages.empty?
 
         @ctx.slug_default!(File.basename(stages.sort.first))
